__doc__ = """EmployX product module.

See README.txt for more details."""


__version__ = '0.0.1'

from Globals import HTMLFile
from Globals import MessageDialog
from Globals import Persistent

import OFS.SimpleItem
import Acquisition
import AccessControl.Role


from Products.ZPatterns.DataSkins import DataSkin
#from Products.ZPatterns.PropertySheets import VirtualSheets

from OFS.SimpleItem import SimpleItem
from OFS.PropertyManager import PropertyManager

manage_addEmployXForm = HTMLFile('dtml/EmployXAdd', globals()) 

def manage_addEmployX(self, emp_id, REQUEST=None):
    """Add a EmployX to a folder."""
    ob = EmployX(emp_id)
    self._setObject(emp_id,ob)
    ob = ob.__of__(self)
    ob.manage_changeProperties(REQUEST=REQUEST)
    
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class EmployX(
        DataSkin,
        SimpleItem,
        Acquisition,
        AccessControl.Role,
        PropertyManager,
    ): 
    """EmployX object. 
    """
        
    meta_type = 'EmployX'

    # Necessary?
    _isRackMountable = 1

    _properties=(
                 {'id':'first', 'type': 'string'},
                 {'id':'last', 'type': 'string'},
                 {'id':'emp_id', 'type': 'string'},
                 {'id':'salary', 'type': 'string'},                 
                )
    
        
    manage_options = ( 
            {'label': 'Edit',       'action': 'manage_main' },
            {'label':'Debug','action':'debug'},        
            {'label': 'View',       'action': 'index_html'}, 
            {'label': 'Security',   'action': 'manage_access'},
        ) 


    __ac_permissions__=( 
                ('View management screens', ('debug','manage_tabs','manage_main')),
                ('Change permissions',      ('manage_access',)           ),
                ('Change EmployX'     ,     ('manage_edit',)             ),
                ('View EmployX',            ('',)                        ),
                )

    def __init__(self,id): 
        """initialise a new instance of EmployX"""
        DataSkin.__init__(self,id)

    def repr(self, obj):
        return repr(obj)    
    
    def debug(self):
        """ Print object's __dict__ """
        result = ""
        for k, v in self.__dict__.items():
            result = "%s\n%s : %s" % (result, repr(k), repr(v))
        return """<body><pre>%s</pre></body>""" % (result)


    manage_main = HTMLFile('dtml/EmployXEdit', globals()) 


    #def saveProperties(self,REQUEST=None,**kw):
    #    """ttw""
    #    pass
        
    
    def manage_edit(self, REQUEST=None): 
        """does this really need a doc string?"""
        self.manage_changeProperties(REQUEST=REQUEST)
        if REQUEST is not None:
            return self.manage_main(self,REQUEST,management_view='Edit')

    
    def editInstance(self,REQUEST=None):
        """ttw"""
        self.manage_changeProperties(REQUEST=REQUEST)
        if REQUEST is not None:
            return self.index_html(self,REQUEST,management_view='View')
            
    #editInstance = HTMLFile('editInstance', globals()) 
    editInstanceForm = HTMLFile('editInstanceForm', globals()) 
    index_html  = HTMLFile('index_html', globals()) 





def initialize(context): 
    """Initialize the EmployX product.
    """
    
   
    context.registerClass(
            EmployX,         
            constructors = (                 
                manage_addEmployXForm, 
                manage_addEmployX),                                                 
            icon = 'www/item.gif'                
        )
    # We need this so that this class will show up in the list of classes
    # Customizers can customize. (Thanks Steve)
    context.registerBaseClass(EmployX)


